#include <iostream>
#include <string>
#include <sstream>

// Person, vollstaendig

using namespace std;


// Begin der Deklaration

class Person{
private:
  int alter;
  string name;
public:
  Person(int, string);            // Konstruktor
  Person();                       // Default-Konstruktor
  ~Person();                      // Destruktor

  string toString();              // ToString-Methode

  int getAlter();                 // Getter fuer alter
  void setAlter(int);             // Setter fuer alter

  string getName();               // Getter fuer name
  void setName(string);           // Setter fuer name

  bool aelterAls(int);          // Aelter als pruefen
  bool aelterAls(Person&);        // Ueberladung: Parameter Person-Referenz
};



// Beginn der Definition (Implementierung)

Person::Person(int a, string n):
alter(a), name(n) {}

Person::Person():
alter(28), name("Katelyn Tarver")
{}

Person::~Person()
{}


string Person::toString(){
  stringstream sStr;
  sStr << name << " (" << alter << ")";
  return sStr.str();
}


int Person::getAlter(){
  return alter;
}

void Person::setAlter(int alter){
  if(alter < 0){
    cout << "Oh... Ein Zukunftsmensch?" << endl;
    return;
  }
  // this ist ein Pointer auf die aktuelle Objektinstanz
  this -> alter = alter;
}


string Person::getName(){
  return name;
}

void Person::setName(string name){
  if(name == ""){
    cout << "Hey, gib der Person doch mal nen Namen..." << endl;
    return;
  }
  // this ist ein Pointer auf die aktuelle Objektinstanz
  (*this).name = name;
}


bool Person::aelterAls(int vgl){
  if(alter > vgl) return true;
  return false;
}

bool Person::aelterAls(Person &vglPerson){
  return alter > vglPerson.alter;
}


// Begin des Tests

int main(){
  // Personen auf dem Stack erstellen
  Person p1 = Person(-1, "Tiffany Alvord");
  Person p2(29, "Kurt Hugo Schneider");

  // Personen auf dem Heap erstellen
  Person* p3 = new Person();
  Person* p4 = new Person(-1, "Brandon Woelfel");

  // Gueltige Alter setzen
  p1.setAlter(24);
  p4 -> setAlter(23);

  // Personen ausgeben auf der Konsole, jeweils mit toString oder Getter
  cout << p1.toString() << endl;
  cout << p2.getName() << " (" << p2.getAlter() << ")" << endl;
  cout << p3 -> getName() << " (" << (*p3).getAlter() << ")" << endl;
  cout << p4 -> toString() << endl;

  // Aelter als:
  if(p1.aelterAls(p2)) cout << p1.getName() << " ist aelter als " << p2.getName() << endl;
  else cout << p1.getName() << " ist juenger als " << p2.getName() << endl;

  if(p3 -> aelterAls(p1)) cout << p3 -> getName() << " ist aelter als " << p1.getName() << endl;
  else cout << p3 -> getName() << " ist juenger als " << p1.getName() << endl;

  delete p3;
  delete p4;
}
